package it.unige.disi.aumlbpel.transformers;

/**
 * @author Giovanni Casella it.unige.disi.aumlbpel.transformers
 *         IntermediateXML_TextualNotation.java Questa classe fornisce utility
 *         per trasfomare un file xml in formato IntermediateXML nel documento
 *         wsdl adatto a supportare un processo bpel.
 */
import org.jdom.*;

import javax.xml.parsers.DocumentBuilderFactory;
import org.jdom.output.*;

import java.io.*;
import java.util.List;
import java.util.Vector;

import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;
import java.io.IOException;
import org.jdom.*;
public class IntermediateXML_FOL {
    private int formatting_tab_number=0;
    
    //ROOT ELEMENTI FONDAMENTALI DEI FILE XML BPEL E WSDL
    //root dei DOM rappresentanti i relativi Files
    private Element rootFOL= new Element("process");
    private String nomeFileFolOut;
    public static void main(String[] argv) throws FileNotFoundException {
        IntermediateXML_FOL trans = new IntermediateXML_FOL();
        String nomeFileIntermediateNotationInput = "E:\\EclipseProject\\FromAUMLToBPELExtended\\resource\\testingFile\\fruit.xml";
        String nomeFileFolOutput = "E:\\EclipseProject\\FromAUMLToBPELExtended\\resource\\testingFile\\fruit.fol";
        trans.tranformXMLtoFOL(nomeFileIntermediateNotationInput,
                nomeFileFolOutput);
    }

 
    public void tranformXMLtoFOL(String nomeFileXmlInput,
            String nomeFileFolOutput) {
        
        this.nomeFileFolOut=nomeFileFolOutput;
        Vector elementVect;
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        Vector nodeVect;
        SAXBuilder builder = new SAXBuilder();
        Element rootXML=null; 
        try {
            //      DOM di Input
            Document xmlDocument;
            xmlDocument = builder.build(nomeFileXmlInput);
            rootXML = xmlDocument.getRootElement();
            } catch (JDOMException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        
        
        File outputFolFile = new File("tmp.txt");
        FileOutputStream outS=null;
        try {
            outS = new FileOutputStream("tmp.txt");
        } catch (FileNotFoundException e1) {
            // TODO Auto-generated catch block
            e1.printStackTrace();
        }
        PrintStream out=new PrintStream(outS);
        writeFol(out,rootXML);
         try {
           cleanFol(outputFolFile);
           outputFolFile.deleteOnExit();
        } catch (FileNotFoundException e2) {
            // TODO Auto-generated catch block
            e2.printStackTrace();
        }
    }

    /**
     * @param outputFolFile
     * Ripulisco il file eliminando le , vicino alle parentesi ,)
     * @throws FileNotFoundException
     */
    private void cleanFol(File outputFolFile) throws FileNotFoundException {
        
	    File tmpF=new File (this.nomeFileFolOut);
	    FileOutputStream tmpos1 = new FileOutputStream(tmpF);
        PrintStream tmp_wr = new PrintStream(tmpos1);
        FileInputStream fis1 = new FileInputStream(outputFolFile);
		InputStreamReader isr1=new InputStreamReader (fis1);
		BufferedReader rdr1 = new BufferedReader(isr1);
		
		
		String lastLine=" ";
		String thisLine="";
		int removeInd;
		try {
		    thisLine=rdr1.readLine();
		    while(thisLine!=null){
		        //Ripulisco la linea da eventuali elementi ,) oppure ,]
		        //String r = Pattern.compile(",\\)").matcher(l).replaceFirst(")");
		        //r=Pattern.compile(",]").matcher(l).replaceFirst("]");
		        if((thisLine.trim().charAt(0)==')')||(thisLine.trim().charAt(0)==']')) {
		          // if(lastLine.charAt(lastLine.length()-1)==',')
		          if(lastLine.endsWith(","))
			        {
		              char[] linA=lastLine.toCharArray();
		              linA[linA.length-1]=' ';
		              lastLine="";
		              for(int i=0;i<linA.length;i++)
		              lastLine=lastLine+linA[i];
		            
		              
			        }
		       	}      
		        
		        if(!lastLine.equals(" ")) tmp_wr.println(lastLine);
		        lastLine=thisLine;
		        thisLine=rdr1.readLine();
		    
		    }
		    if(!lastLine.equals(" ")) tmp_wr.println(lastLine);
	       
		    
		    
		    tmpF.renameTo(outputFolFile);
		    tmpF.delete();
	        
	        
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

        
    }


    /**
     * Analizza il processo descritto a partire dal tag
     * main-interaction-fragment 
     * @param out
     *  
     */
    private void processMainFragment(PrintStream out, Element rootXML) {
        FormattingPrintln(out,"%%% Definition of the body contained in the WS_BPEL file %%%");
        FormattingPrintln(out,"main_fragment(");
        
        Vector nodeVect;
        List children;
        nodeVect = extractNodebyName(rootXML.getChildren(),
                "main-interaction-fragment");
        Element tmp = (Element) nodeVect.get(0);
        children = tmp.getChildren();
        Element t;
        for (int i = 0; i < children.size(); i++) {
            t = (Element) children.get(i);
            if (t.getName().equals("message")) {
                processMessage(out,t);
            } else if (t.getName().equals("combined-fragment"))
                processCombinedFragment(out,t);

        }
        FormattingPrintln(out,")");
        
    }

    
    
    
 
void writeFol(PrintStream out,Element rootXML){
    Vector elementVector = extractNodebyName(rootXML.getChildren(), "parameters");
if (elementVector.size() == 0)
    throw new IllegalArgumentException(
            " Il file xml contiene errori relativi al tag params che deve essere inserito obbligatoriamente.");
Element tmp = (Element) elementVector.get(0);
String res[] = extractValueFromMandatoryParam(tmp.getText());
String ontology = res[0];
String content_language_name = res[1];
//Protocol Name
elementVector = extractNodebyName(rootXML.getChildren(),
        "protocol-name");
tmp = (Element) elementVector.get(0);
String protocol_name =tmp.getText();
//Agent Publisher
elementVector = extractNodebyName(rootXML.getChildren(),"agent-publisher");
tmp = (Element) elementVector.get(0);
String[] val = ExtractNameRoleClass(tmp.getText(), true);
String pubName = val[0];
String pubRole = val[1];
String pubClass= val[2];
//Agent Reader
elementVector = extractNodebyName(rootXML.getChildren(), "agent-reader");
tmp = (Element) elementVector.get(0);
val = ExtractNameRoleClass(tmp.getText(), false);
String readName = val[0];
String readRole = val[1];
String readClass= val[2];
//
FormattingPrintln(out,"process(");
formatting_tab_number++;
FormattingPrintln(out,"parameters(");
formatting_tab_number++;
FormattingPrintln(out,"ontology('"+ontology+"'),");
FormattingPrintln(out,"content_language('"+content_language_name+"')");
formatting_tab_number--;
FormattingPrintln(out,"),");
FormattingPrintln(out,"%%% Definition of the protocol name %%%");
FormattingPrintln(out,"protocol_name('"+protocol_name+"'),");
FormattingPrintln(out,"%%% Definition of the agent publisher %%%");
FormattingPrintln(out,"agent_publisher(short_name('"+pubRole+"@address'),long_name('"+pubName+"/"+pubRole+":"+pubClass+"')),");
FormattingPrintln(out,"%%% Definition of the agent reader %%%");
FormattingPrintln(out,"agent_reader(short_name('"+readRole+"@address'),long_name('"+readName+"/"+readRole+":"+readClass+"')),");


//*******************************************
//*******************************************
processMainFragment(out,rootXML); 



formatting_tab_number--;
FormattingPrintln(out,")");

}



    /**
     * Scrive sui rispettivi File l'albero DOM rapprensetante il documento Bpel
     * e quello che rapprensenta il documento Wsdl
     * 
     * @param nomeFileWsdlOutput
     * @param nomeFileBpelOutput
     */
    private void writeDoms(String nomeFileWsdlOutput, String nomeFileBpelOutput) {
        File outputWsdlFile = new File(nomeFileWsdlOutput);
        File outputBpelFile = new File(nomeFileBpelOutput);
        OutputStream outWsdl, outBpel;
        try {
            outWsdl = new FileOutputStream(outputWsdlFile);
            outBpel = new FileOutputStream(outputBpelFile);
            //          SCRITTURA OUTPUT Wsdl e Bpel
            XMLOutputter outputter = new XMLOutputter();
            outputter.output(rootFOL, outWsdl);
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }

    }

   
        

  
    
    private void processMessage(PrintStream out, Element t) {

        String SenderType;
        String sender;
        String communicative_act;
        String receiver;
        String content;
        Vector v;
        v = extractNodebyName(t.getChildren(), "sender");
        sender = ((Element) v.get(0)).getText();
        v = extractNodebyName(t.getChildren(), "communicative-act");
        communicative_act = ((Element) v.get(0)).getText();
        v = extractNodebyName(t.getChildren(), "content");
        content=((Element) v.get(0)).getText();
       String readerOp;
        if(sender.equals("publisher")) readerOp="receive";
       else readerOp="send";
       //send(msg('REQUEST', 'accepted_payment_methods')),
       String s = readerOp +"(msg('" + communicative_act.toUpperCase()+"','"+content+"')),";
       FormattingPrintln(out,s);
       }

    private void processCombinedFragment(PrintStream out,Element t) {

        Vector v = extractNodebyName(t.getChildren(), "type");
        Element type = (Element) v.get(0);
        String ti = type.getText();
        if (ti.equals("loop"))
            processLoopCF(out,t);
        else if (ti.equals("seq"))
            processSequenceCF(out,t);
        else if (ti.equals("alt"))
            processAltCF(out,t);
        else if (ti.equals("opt"))
            processOptCF(out,t);

    }

    
    private void processSequenceCF(PrintStream out,Element cf) {

        Element tmp;
        formatting_tab_number++;
        FormattingPrintln(out,"seq([");
        Vector v = extractNodebyName(cf.getChildren(), "fragment");
        for (int i = 0; i < v.size(); i++) {

            Element frag = (Element) v.get(i);
            List frag_childs = frag.getChildren();
            for (int h = 0; h < frag_childs.size(); h++) {
                Element t2 = (Element) frag_childs.get(h);
                if (t2.getName().equals("message")) {
                    processMessage(out,t2);

                } else if (t2.getName().equals("combined-fragment")) {
                    processCombinedFragment(out,t2);
                }
            }
        }
        FormattingPrintln(out,"]),");
        formatting_tab_number--;
    }

    

    private void processLoopCF(PrintStream out, Element cf) {
        Element tmp;
        formatting_tab_number++;
        //if_then((accepted, equal, true), [
        FormattingPrintln(out,"while(no_guard,");
        Vector v = extractNodebyName(cf.getChildren(), "fragment");
        for (int i = 0; i < v.size(); i++) {

            Element frag = (Element) v.get(i);
            List frag_childs = frag.getChildren();
            for (int h = 0; h < frag_childs.size(); h++) {
                Element t2 = (Element) frag_childs.get(h);
                if (t2.getName().equals("message")) {
                    processMessage(out,t2);

                } else if (t2.getName().equals("combined-fragment")) {
                    processCombinedFragment(out,t2);
                }
            }
        }
        FormattingPrintln(out,"),");
        formatting_tab_number--;
    
    }

    private void processAltCF(PrintStream out,Element cf) {
        formatting_tab_number++;
        FormattingPrintln(out,"switch([");
        Vector v = extractNodebyName(cf.getChildren(), "fragment");
        Element t, tmp;
        List FragmentChilds;
        Element opt_el = new Element("option");
        
        for (int i = 0; i < v.size(); i++) {
            t = (Element) v.get(i);
            formatting_tab_number++;
            FormattingPrintln(out,"case(no_guard,");
            
            FragmentChilds = t.getChildren();
            for (int j = 0; j < FragmentChilds.size(); j++) {
                tmp = (Element) FragmentChilds.get(j);
                if (tmp.getName().equals("message")) {
                    processMessage(out,tmp);

                } else if (tmp.getName().equals("combined-fragment")) {
                    processCombinedFragment(out,tmp);
                }
                FormattingPrintln(out,"),");
                formatting_tab_number--;
             }
            
        }
        FormattingPrintln(out,"]),");
        formatting_tab_number--;
    }

    private void processOptCF(PrintStream out,Element cf) {
        Element tmp;
        formatting_tab_number++;
        //if_then((accepted, equal, true), [
        FormattingPrintln(out,"if_then(no_guard,");
        Vector v = extractNodebyName(cf.getChildren(), "fragment");
        for (int i = 0; i < v.size(); i++) {

            Element frag = (Element) v.get(i);
            List frag_childs = frag.getChildren();
            for (int h = 0; h < frag_childs.size(); h++) {
                Element t2 = (Element) frag_childs.get(h);
                if (t2.getName().equals("message")) {
                    processMessage(out,t2);

                } else if (t2.getName().equals("combined-fragment")) {
                    processCombinedFragment(out,t2);
                }
            }
        }
        FormattingPrintln(out,"),");
        formatting_tab_number--;
    
    }

    private void addProtocolElementsDeclaration() {
        Element tmp, nuovo;
        Vector elementVector;
        String pubName, pubRole, readName, readRole,pubClass,readClass;
        Element rootXML = null;
        elementVector = extractNodebyName(rootXML.getChildren(), "parameters");

        if (elementVector.size() == 0)
            throw new IllegalArgumentException(
                    " Il file xml contiene errori relativi al tag params che deve essere inserito obbligatoriamente.");

        
        tmp = (Element) elementVector.get(0);
        String res[] = extractValueFromMandatoryParam(tmp.getText());
        String ontology = res[0];
        String content_language_name = res[1];
        
        nuovo = new Element("paremeters");
        
        nuovo.setAttribute("ontology",ontology);
        nuovo.setAttribute("content-language",content_language_name);
        
        
        //Protocol Name
        elementVector = extractNodebyName(rootXML.getChildren(),
                "protocol-name");
        tmp = (Element) elementVector.get(0);
        nuovo.setAttribute("protocol-name",tmp.getText());
        //      Agent Publisher
        elementVector = extractNodebyName(rootXML.getChildren(),
                "agent-publisher");
        tmp = (Element) elementVector.get(0);
        String[] val = ExtractNameRoleClass(tmp.getText(), true);
        pubName = val[0];
        pubRole = val[1];
        pubClass = val[2];
        nuovo.setAttribute("publisher", pubName + "/" + pubRole +":"+pubClass);

        //Agent Reader
        elementVector = extractNodebyName(rootXML.getChildren(), "agent-reader");
        tmp = (Element) elementVector.get(0);
        val = ExtractNameRoleClass(tmp.getText(), false);
        readName = val[0];
        readRole = val[1];
        	readClass = val[2];
        	nuovo.setAttribute("reader", readName + "/" + readRole +":"+readClass);
        	
        }



    /**
     * Prende in input una stringa del tipo jm/jobsManager:jobsManagerClass la
     * scompone e ne restituisce gli elementi se uno degli elementi manca ad
     * esempio per una stringa del tipo jm/: vengono restituiti gli elemengi di
     * defualt Se publisher  true si usano i valori di default per il publisher
     * altrimenti quelli per il reader in Result[0] viene restituito lo name
     * Result[1] viene restituito il role Result[2] viene restituito la classe
     * 
     * @param s
     * @return
     */

    private String[] ExtractNameRoleClass(String s, boolean publisher) {
        String[] result = new String[3];
        String name, role, classe;
        int start, end;
        end = s.indexOf("/");
        name = s.substring(0, end);
        String suff = "Publisher";
        if (publisher == false)
            suff = "Reader";

        if (name.length() == 0)
            name = "defaultAgentName" + suff;

        start = s.indexOf("/") + 1;
        end = s.indexOf(":");
        role = s.substring(start, end);
        if (role.length() == 0)
            name = "defaultAgentRole" + suff;

        start = s.indexOf(":") + 1;
        classe = s.substring(start);
        if (classe.length() == 0)
            name = "defaultClasseRole" + suff;

        result[0] = name;
        result[1] = role;
        result[2] = classe;

        return result;

    }

    /**
     * Restituisce un vettore contenente tutti i nodi con un certo nome tagName
     * individuati nella nodeList in input
     * 
     * @param nl
     *            Lista Nodi in cui ricercare
     * @param tagName
     *            Nome del tag da ricercare
     * @return Vettore con i nodi in nl aventi tagName
     */
    private Vector extractNodebyName(List l, String tagName) {
        Vector result = new Vector();
        org.jdom.Element tmp;
        for (int i = 0; i < l.size(); i++) {
            tmp = (org.jdom.Element) l.get(i);
            if (tmp.getName().equals(tagName))
                result.add(tmp);
        }
        return result;
    }

    /**
     * I param di un protocollo di comunicazione sono esperess nell'xml
     * intermedio secondo la notazione <mandatory-params>< <mandatory params>>
     * ontology = "job_search" content-language = "first order logic"
     * </mandatory-params>
     * 
     * @param s
     *            contenuto del tag mandatory param
     * @return stringhe relative all'ontologia ed al content language
     */

    private String[] extractValueFromMandatoryParam(String s) {
        String[] result = new String[2];
        String ontology;
        String cl;
        int start, end;
        start = s.indexOf("ontology") + 8;
        end = s.indexOf("CL");
        ontology = s.substring(start, end).trim();
        if (ontology.length() == 0)
            throw new IllegalArgumentException(
                    "Il file xml contiene errori relativi al tag mandatory-params (ontology)");
        ontology = ontology.replaceAll("=", "");
        ontology = ontology.replaceAll("\"", "");
        ontology = ontology.replaceAll("ontology", "");
        result[0] = ontology.trim();

        start = s.indexOf("CL");
        cl = s.substring(start+("CL".length())).trim();
        if (cl.length() == 0)
            throw new IllegalArgumentException(
                    "Il file xml contiene errori relativi al tag mandatory-params (content-language)");
        cl = cl.replaceAll("=", "");
        cl = cl.replaceAll("\"", "");
        cl = cl.replaceAll("content-language", "");
        result[1] = cl.trim();
        return result;

    }

    /**
     * Estrae le informazioni relative agli agenti. Nella notazione xml
     * intermedia sono presenti i tag <agent-publisher>e <agent-reader>del
     * seguente tipo <agent-publisher
     * short-name="p">jm/jobsManager:jobsManagerClass </agent-publisher> La
     * funzione retituisce i dati in un formato proprio del linguaggio testuale
     * 
     * @param s
     *            Contenuto di <agent-publisher>o <agent-reader>
     * @return informazioni formattate
     */
    private String extractValueFromAgentTag(String s) {
        String result = "";
        String name, role, classe;
        int start, end;

        start = s.indexOf(">") + 1;
        end = s.indexOf("/");
        name = s.substring(start, end).trim();
        if (name.length() == 0)
            name = "df-agent-name";

        start = s.indexOf("/") + 1;
        end = s.indexOf(":");
        role = s.substring(start, end).trim();
        if (role.length() == 0)
            name = "df-role-name";

        start = s.indexOf(":") + 1;
        end = s.indexOf("<", start);
        classe = s.substring(start, end).trim();
        if (classe.length() == 0)
            name = "df-class-name";

        result = name + " " + role + " " + classe + " ";
        return result;

    }
    
    /**
     * Stampa la stringa s formattandola correttamente
     * 
     * @param out
     * @param s
     */
    private void FormattingPrint(PrintStream out, String s) {
        for (int i = 0; i < formatting_tab_number; i++) {
            s = "   " + s;
        }
        //s="\t"+s;}
        out.print(s);

    }

    /**
     * Stampa la stringa s formattandola correttamente e andando a capo
     * 
     * @param out
     * @param s
     */
    private void FormattingPrintln(PrintStream out, String s) {
        for (int i = 0; i < formatting_tab_number; i++) {
            s = "   " + s;
            //s="\t"+s;}

        }
        out.println(s);

    }
    

}